/*
 * Focal, 1981.
 * Dedicated to the old times,
 * when an 8k PDP-8 was considered
 * a BIG machine.
 * Driver and command handler.
 */

#include	"focal.h"

#ifdef	vms
   #include        <stsdef.h>
   #include        <ssdef.h>
   #define IO_SUCCESS      SS$_NORMAL
   #define IO_ERROR        (STS$M_INHIB_MSG | SS$_ABORT)
#else
   #ifndef IO_SUCCESS
      #define IO_SUCCESS      0
   #endif
   #ifndef IO_ERROR
      #define IO_ERROR        1
   #endif
#endif

/*----------------------------------------------------------------*/
/*                       global variables                         */
/*----------------------------------------------------------------*/

char	cbuf[128];			/* Command buffer */
char	abuf[128];			/* Ask buffer */
char    *filename;                      /* Filename in use */
char    *command = "edit ";             /* Line command for modify */
char    *ctp;                           /* Current text pointer */
char    *copiactp[80];                  /* Used in user function */
char    *extension = ".foc";            /* Focal DOS standard extension */
struct  line    *line;                  /* Line list header */
struct	line	*clp;			/* Current line pointer */
int	mode;				/* Current processing mode */
struct	sym	*forsp;			/* Symbol pointer (for) */
double	forlimit;			/* Loop limit (for) */
double	forstep;			/* Loop step (for) */
struct	control	*control;		/* Control stack */
jmp_buf	env;				/* Saved state for errors */
int	intflag;			/* Interrupt flag */
int     firsttime;                      /* View intro */
long    seed;                           /* random number seed */
int     execute = 0;                    /* =1 gets cbuf from string */
					/* =0 gets cbuf from keyboard */
int     traceflag = 0;                  /* =0 trace off, =1 trace on */
struct  sym     *sym[N_HASH + 1];       /* Symbol table */
FILE    *fc[10];                        /* File channels 1..9 */
char    filetable[10]="WXXXXXXXXX";     /* File type for channel */
					/* channel 0 open in output for */
					/* printer */
int     reserved = 0;                   /* =1 if set reserved var */
char    timebuf[9], datebuf[9];         /* for output of time & day */
char    *user = "&";                    /* workspace for user function */
int     c1, c2 = 0;                     /* service vars for fusr */
int     breakflag = 0;                  /* used in break command */
int     graphicmode = 0;                /* 0=text, 1=640x200, 2=640x480 */
char far *vdu = 0xB8000000 ;            /* pointer to video buffer */
int     forindex = 0, toggle = 0;       /* vars for one-line nested for loops */
int     foutflag, foutvalue, finflag;   /* vars for fout & fin */

double secondary();
double tertiary();
void delay(float value);
void incrementcmd();
void askcmd();
void typecmd();
void librarycmd();
void helpcmd();
char *replace(char *st, char *orig, char *repl);
void tracedata();
double fusr(double arg);
double fout(double arg);
double fin(double arg);
int checkoverflow(double i, double j, int n);
void mysetpixel(int riga, int colonna, int colore);
void swap(int *i, int *j);
void setfunctions();
char *timestr( unsigned d, char *buf );
char *datestr( unsigned d, char *buf );

int main(int argc, char *argv[])
{
	register int    c;
		 int   ii;

#ifdef FUNCTIONS
        setfunctions();
#endif

	setjmp(env);
        catchcc();
        /* Seed random number generator */
        time (&seed);
        srand (seed);
     
	fc[0] = fopen("prn","w");   /* channel 0 for printer */

	if (firsttime == 0) {
	    clearscreen();
	    printf("-----------------------------------\n");
	    printf("FOCAL INTERPRETER for MS-DOS 2.20\n");
	    printf("      with graphic extensions\n");
	    printf("    Type 'help *' for help or\n");
	    printf("        see FOCAL.TXT\n");
	    printf("-----------------------------------\n");
            firsttime++;
	    if (argc == 2) {
		 strcpy(cbuf,"library run ");
		 strcat(cbuf,argv[1]);
		 if (strstr(argv[1],extension) == NULL)
		      strcat(cbuf,extension);
		 execute = 1;
	    }
	}
        for (;;) {
		if ((c2 == 1) && (c1 == 1)) {
		    c1 = 0; c2 = 0;
		    strcpy(cbuf,"library call focaltmp.foc");
		    goto skip;
		}
		putchar('*');
		if (execute == 1) {
		     printf("%s\n",cbuf);
		     execute = 0;
		  }
		  else {
		     for (ii=0;ii<=128;++ii)
			cbuf[ii]='\0';

		     if (gets(cbuf) == NULL) {
			putchar('\n');
			break;
		     }
		}
skip:
		mode = C_TOP;
		clp  = NULL;
		ctp  = cbuf;
		if ((c=getnb()) != 0) {
			if (isdigit(c))
				inject(c);
			else {
				--ctp;
				process();
			}
		}
	}
	return EXIT_SUCCESS;
}

/*
 * Handcraft the symbol table
 * entry for a builtin function. Used
 * at initialization time, to jam
 * the functions into the table, and
 * never used again!
 */
void builtin(cp, fp)
char	*cp;
double	(*fp)();
{
	register struct sym *sp = NULL;
	int	ix;
	
	sp = (struct sym *)malloc(sizeof(*sp)+strlen(cp)+1);
	if (sp == NULL) {
		fprintf(stderr, "No memory for %s\n", cp);
		exit(IO_ERROR);
	}
	ix = hashname(cp);
	sp->s_fp = sym[ix];
	sym[ix] = sp;
	sp->s_type = S_FUNC;
	sp->s_subs = 0;
	sp->s_un.s_fp = fp;
	strcpy(sp->s_id, cp);
}


void builtinvar(cp,fp)
char    *cp;
double  fp;
{
	register struct sym *sp = NULL;
	int     ix;

	sp = (struct sym *)malloc(sizeof(*sp)+strlen(cp)+1);
	if (sp == NULL) {
		fprintf(stderr, "No memory for %s\n", cp);
		exit(IO_ERROR);
	}
	ix = hashname(cp);
	sp->s_fp = sym[ix];
	sym[ix] = sp;
	sp->s_type = S_SCAL;
	sp->s_subs = 0;
	sp->s_un.s_value = fp;
	/* sp->s_un.s_fp = fp; */
	strcpy(sp->s_id, cp);

}

/* #ifdef  DEBUG */
void dumpsyms()
{
	register struct sym *sp;
	int	i;
	
	for (i = 0; i < N_HASH; ++i) {
		printf("%3d:", i);
		for (sp = sym[i]; sp != NULL; sp = sp->s_fp) {
			if (sp->s_type == S_ARRAY) {
				printf(" %s(%d)", sp->s_id, sp->s_subs);
				printf(" %f", sp->s_un.s_value); }
			if (sp->s_type == S_SCAL) {
				printf(" %s", sp->s_id);
				printf(" %f", sp->s_un.s_value); }
			if (sp->s_type == S_FUNC) {
				printf(" %s", sp->s_id);
				}
		}
		printf(" $\n");
		if (((i+1) % 20) == 0)
		    getchar();
	}
}
/* #endif */

/*
 * This is the line evaluator. It runs
 * the do/for/return stack, checks for interrupts
 * and calls the required subfunctions to get
 * the focal commands executed.
 */
void process()
{
	double		limit, step = 1.0;
	double		value;
	register int	c;
	register struct sym *sp;
	register struct line *lp;
	struct lno	lno;
	struct line	*lp1, *lp2, *lp3;
	int             grp = 0;
	int             zjump,all;
	char            temp[80];
	char            separator='\\';
	char            oldpattern[40];
	char            newpattern[40];
	char            savectp[120];
	char            linenum[10];
	int             result,index;
	int             x,y,n1,n2,n3;
	double          vtemp;
	FILE            *ftmp;
loop:
	if (intflag) {
		intflag = 0;
		diag("^C");
	}

	if (traceflag == 1)
	    tracedata();

	while ((c=getnb()) == ';')
		;
	if (c == 0) {
Iloop:
		if (mode == C_FOR) {
			if (breakflag == 1) {
			     vtemp=forsp->s_un.s_value;
			     forsp->s_un.s_value = forlimit+1;
			     }
			   else
			     forsp->s_un.s_value += forstep;
			if ((forstep>0.0 && forsp->s_un.s_value<=forlimit)
			||  (forstep<0.0 && forsp->s_un.s_value>=forlimit)) {
				clp = control->c_lp;
				ctp = control->c_tp;
				goto loop;
			}
			if (breakflag == 1) {
			   forsp->s_un.s_value = vtemp;
			   breakflag = 0; }
			popfor();
			if (toggle !=0) {
			    if (forindex > 0) {
				forindex--;
				goto Iloop; }
			     else {
				toggle = 0;
				forindex = 0;
				}
			}
		}
		if (clp != NULL) {
			grp = clp->l_gno;
			clp = clp->l_fp;
			ctp = clp->l_text;
		}
		if (clp == NULL) {
			if (mode == C_TOP)
				return;
			popdo();
		} else if (mode == C_DLINE
		|| (mode==C_DGRP && grp!=clp->l_gno))
			popdo();
		goto loop;
	}

	while (isalpha(*ctp))
		++ctp;
	if (isupper(c))
		c = tolower(c);
	switch (c) {

	case 'a':
		askcmd();
		break;

	case 'b':
		if (control == NULL)
		      diag("Break not in for loop");

		getlno(&lno, -1);
		if (lno.ln_type == LN_NONE) {
			diag("Break without line number");
		} else if (lno.ln_type == LN_LINE) {
			lp = line;
			while (lp != NULL
			&& (lp->l_gno != lno.ln_gno
			||  lp->l_lno != lno.ln_lno))
				lp = lp->l_fp;
			if (lp != NULL) {
				clp = lp;
				ctp = clp->l_text;
				breakflag = 1;
				goto loop;
			}
		}
		badline();


	case 'c':
		while (*ctp != 0)
			++ctp;
		break;

	case 'd':
		getlno(&lno, -1);
		pushcntl();
		if (lno.ln_type==LN_NONE || lno.ln_type==LN_ALL) {
			if ((clp=line) == NULL)
				diag("No program");
			ctp = clp->l_text;
			mode = C_DALL;
			goto loop;
		}
		if (lno.ln_type == LN_GRP) {
			lp = line;
			while (lp!=NULL && lp->l_gno<lno.ln_gno)
				lp = lp->l_fp;
			if (lp!=NULL && lp->l_gno==lno.ln_gno) {
				clp = lp;
				ctp = clp->l_text;
				mode = C_DGRP;
				goto loop;
			}
			badline();
		}
		lp = line;
		while (lp != NULL
		&& (lp->l_gno != lno.ln_gno
		||  lp->l_lno != lno.ln_lno))
			lp = lp->l_fp;
		if (lp != NULL) {
			clp = lp;
			ctp = clp->l_text;
			mode = C_DLINE;
			goto loop;
		}
		badline();

	case 'e':
		getlno(&lno, -1);
		if (lno.ln_type == LN_NONE) {
			erasesyms();
			setfunctions();
			break;
		}
		lp1 = NULL;
		lp2 = line;
		while (lp2 != NULL) {
			if (lno.ln_type == LN_ALL
			|| (lp2->l_gno  == lno.ln_gno
			&& (lno.ln_type==LN_GRP || lp2->l_lno==lno.ln_lno))) {
				if (lp2 == clp)
					diag("Erasing current line");
				lp3 = lp2;
				lp2 = lp2->l_fp;
				if (lp1 == NULL)
					line = lp2; else
					lp1->l_fp = lp2;
				free((char *) lp3);
			} else {
				lp1 = lp2;
				lp2 = lp2->l_fp;
			}
		}
		if (lp2 == NULL)
		   strcpy(filename,"");
		break;

	case 39:
		if (forindex !=0)
		    toggle = 1;   /* one-line nested loops */
		break;

	case 'f':
		sp = getsym();

		if (reserved == 1) {
		     reserved = 0;
		     diag("Can't set reserved var");
		}

		clearfors(sp);
		if (getnb() != '=')
			diag("Missing = sign");
		sp->s_un.s_value = eval();
		if (getnb() != ',')
			diag("Missing comma");
		limit = eval();

		if ((c=getnb()) == ';')
			step = 1.0;
		else if (c == ',') {
			step = eval();
			vtemp = limit;  /* equal to PDP Focal syntax */
			limit = step;
			step = vtemp;
			if (getnb() != ';')
				diag("Missing semicolon");
		} else
			diag("Bad for");


		/* skip for loop if limit < initial */
		if (((sp->s_un.s_value > limit) && step > 0) ||
		    ((sp->s_un.s_value < limit) && step < 0))
		{
		   while (*ctp != 0)
			++ctp;
		   break;
		}
		/* to check */

		pushcntl();
		forsp = sp;
		forlimit = limit;
		forstep = step;
		mode = C_FOR;
		breakflag = 0;
		forindex++;
		break;

	case 'g':
		getlno(&lno, -1);
		if (lno.ln_type == LN_NONE) {

			ftmp=fopen("focaltmp.foc","w");
			save(NULL,ftmp);
			fclose(ftmp);
			c1 = 1;

			if ((clp=line) == NULL)
				diag("No program");
			ctp = clp->l_text;
			goto loop;
		} else if (lno.ln_type == LN_LINE) {
			lp = line;
			while (lp != NULL
			&& (lp->l_gno != lno.ln_gno
			||  lp->l_lno != lno.ln_lno))
				lp = lp->l_fp;
			if (lp != NULL) {
				clp = lp;
				ctp = clp->l_text;
				goto loop;
			}
		}
		badline();

	case 'i':
		value = eval();
		if (value >= 0.0) {
			while ((c = *ctp)!=0 && c!=',' && c!=';')
				++ctp;
			if (c != ',')
				goto loop;
			++ctp;
			if (value != 0.0) {
				while ((c = *ctp)!=0 && c!=',' && c!=';')
					++ctp;
				if (c != ',')
					goto loop;
				++ctp;
			}
		}

		if (*ctp == ',') {
		   while ((c = *ctp)!=0 && c!=';')
			  ++ctp;
		   goto loop;
		}

		getlno(&lno, -1);
		if (lno.ln_type == LN_LINE) {
			lp = line;
			while (lp != NULL
			&& (lp->l_gno != lno.ln_gno
			||  lp->l_lno != lno.ln_lno))
				lp = lp->l_fp;
			if (lp != NULL) {
				clp = lp;
				ctp = clp->l_text;
				goto loop;
			}
		}
		badline();

        case 'j':
		value = eval();
		zjump = 2;

                do {
		     if (value < zjump)
			 break;

		     while ((c = *ctp)!=0 && c!=',' && c!=';')
                           ++ctp;

		     if ((c = *ctp) == 0 || c ==';') {
			if (value >= zjump)
			   goto loop;
			break;
		     }

		     if (c != ',')
                            goto loop;
                     ++ctp;
                
		     zjump = zjump + 1;

		} while (1);

		getlno(&lno, -1);
		if (lno.ln_type == LN_LINE) {
			lp = line;
			while (lp != NULL
			&& (lp->l_gno != lno.ln_gno
			||  lp->l_lno != lno.ln_lno))
				lp = lp->l_fp;
			if (lp != NULL) {
				clp = lp;
				ctp = clp->l_text;
				goto loop;
			}
		}
		badline();

	case 'o':   /* on <expression> l1,l2,ln */
		value = eval();
		zjump = 2;

		do {
		     if (value < zjump)
			 break;

		     while ((c = *ctp)!=0 && c!=',' && c!=';')
			   ++ctp;

		     if ((c = *ctp) == 0 || c ==';') {
			if (value >= zjump)
			   goto loop;
			break;
		     }

		     if (c != ',')
			    goto loop;
		     ++ctp;

		     zjump = zjump + 1;

		} while (1);

		getlno(&lno, -1);
		pushcntl();

		if (lno.ln_type == LN_LINE) {
		   lp = line;
		   while (lp != NULL
		   && (lp->l_gno != lno.ln_gno
		   ||  lp->l_lno != lno.ln_lno))
			   lp = lp->l_fp;
		   if (lp != NULL) {
			clp = lp;
			ctp = clp->l_text;
			mode = C_DLINE;
			goto loop;
		   }
		}
		badline();

	case 'l':
		librarycmd();
		break;

	case 'm':
		strcpy(linenum,ctp);
		for (index=1;index<=strlen(linenum);++index) {
		      if (linenum[index]==' '){
			      linenum[index]='\0';
			      break;
		      }
		}
		if (linenum[1] == 'a') {
		if (clp == NULL) {
			if (strlen(filename) == 0)
			     printf("Save your program before use modify command!\n");
			 else {
			     strcpy(temp, command);
			     strcat(temp, filename);
			     strcat(temp,"");
			     system(temp);
			     strcpy(cbuf,"library call ");
			     strcat(cbuf, filename);
			     execute = 1;
			}
		}
		return;
		}
		getlno(&lno, -1);
		strcpy(savectp,ctp);
		if (lno.ln_type == LN_NONE) {
			if ((clp=line) == NULL)
				diag("No program");
			ctp = clp->l_text;
			goto loop2;
		} else if (lno.ln_type == LN_LINE) {
			lp = line;
			while (lp != NULL
			&& (lp->l_gno != lno.ln_gno
			||  lp->l_lno != lno.ln_lno))
				lp = lp->l_fp;
			if (lp != NULL) {
				clp = lp;
				ctp = clp->l_text;
				goto loop2;
			}
		}
		badline();
		break;
loop2:          for (result=0; result<=strlen(savectp);++result) {
		    if (savectp[result]==separator)
			break;
		}
                if ((result -1) == strlen(savectp))
			diag("Wrong format");

                for (index=1;index<result;++index)
		    oldpattern[index-1]=savectp[index];
		oldpattern[result-1]='\0';

		for (index=result+1;index<=strlen(savectp);++index)
		    newpattern[index-result-1]=savectp[index];
		newpattern[strlen(savectp)]='\0';
		strcpy(savectp, replace(ctp,oldpattern,newpattern));
		strcpy(cbuf,linenum);
                strcat(cbuf,savectp);
                execute=1;
		return;

	case 'q':
		if (clp == NULL) {
			setattribute(0);
			setcolor(7,0); /* restore attribute and color
					  defaults (white on black) */
			fclose(fc[0]);       /* close printer */
			exit(IO_SUCCESS);
		}
		return;

	case 't':
		typecmd();
		break;

	case 'r':
		while (mode == C_FOR)
			popfor();
		popdo();
		break;

	case 's':
		sp = getsym();

		if (reserved == 1) {
		     reserved = 0;
		     diag("Can't set reserved var");
		}

		if (getnb() != '=')
			diag("Missing = sign");

		finflag = 1;
		sp->s_un.s_value = eval();
		finflag = 0;
		break;

	case 'k':
		getch();
		break;

	case 'h':
		if (clp == NULL)
		    helpcmd();
		  else {
		     delay(eval());
		}
		break;

	case 'w':
		getlno(&lno, -1);
		save(&lno, stdout);
		break;

	case 'v':
		if (clp == NULL)
		    dumpsyms();
		break;

	case '$':
		if (clp == NULL)
		    dumpsyms();
		break;

	case 'x':
		system("command");
		break;

        case 'y':
                incrementcmd();
                break;

	case 'u':
		strcpy(user,ctp);
		while (*ctp != 0)
			++ctp;
		break;

	case '?':
		traceflag = 1 - traceflag;
		if (traceflag == 0)
		    printf("Trace off\n");
		 else
		    printf("Trace on\n");
		break;

	case 'n':   /* notify */
            while ((c=getnb())!=0 && c!=';') {
                 if (isupper(c))
                      c = tolower(c);
                 if (c == 'd') {
		      _strdate(datebuf);
		      printf("%s\n",datebuf);
		      break;}
		 if (c == 't') {
		      _strtime(timebuf);
		      printf("%s\n",timebuf);
		      break; }
		 if (c == 'u') {
		      printf("USER DEFINITION: %s\n",user);
		      break; }
		 if (c == 'm') {
		      printf("MEMORY AVAILABLE: %u\n",_memavl());
		      break; }
		 if (c == 'f') {
		      printf("FILE IN USE: %s\n",filename);
		      break; }
		 if (c == 'p') {
		      n1 = 0; n2 = 0;
		      while (isalpha(*ctp))
			   ++ctp;

		      while ((c=getnb())!=0 && c!=';') {

			 if (c == ',')
			      continue;

			 --ctp;
			 n2 = (int) eval();
			 swap(&n2, &n1);
		      }
		      screenposition(n2,n1);
		      --ctp;
		      break;
		 }
		 if (c == 'g') {
		      if (clp == NULL) {
                           diag("Only in program mode"); }
			else {
			   graphicmode = 1;
			   vdu = 0xB8000000;
			   clearscreen();
			   setdisplaymode(6); }
		      break; }
		 if (c == 'x') {
		      if (clp == NULL) {
                           diag("Only in program mode"); }
			else {
			   graphicmode= 2;
			   vdu = 0xA0000000;
			   clearscreen();
			   setdisplaymode(17); }
		      break; }
		 if (c == 'n') {
		      if (clp != NULL) {
			   graphicmode = 0;
			   setdisplaymode(3);
			   break; }
			else
                           diag("Only in program mode");
		      }
		 diag("Wrong format");
            }
            while ((c=getnb()) !=0 && c!=';');
            --ctp;
            break;

        case 'z':
	    if (strstr(ctp," $") == ctp) {
               erasesyms();
	       setfunctions();
               while ((c=getnb())!=0 && c!=';')
		 ;
	       --ctp;
	       break;
	    }

          while ((c=getnb())!=0 && c!=';') {

		if (c == ',')
			continue;
		--ctp;
		sp = getsym();

		if (reserved == 1) {
		     reserved = 0;
		     diag("Can't set reserved var");
		}
		sp->s_un.s_value = 0;
	}
        --ctp;
        break;

        case 'p':
	    if (clp == NULL)
		 diag("Only in pogram mode");

	    if (graphicmode == 0)
		 diag("No graphic available");

	    n1 = 0; n2 = 0; n3 = 0;
	    while ((c=getnb())!=0 && c!=';') {

		if (c == '@' || c == '"')
			diag("Wrong format");

		if (c == ',')
			continue;
		--ctp;
		n3 = (int) eval();
		swap(&n3, &n2);
		swap(&n2, &n1);
            }
	    mysetpixel(n3,n2,n1);
	    --ctp;
	    break;


	default:
		diag("Illegal command");
	}
	goto loop;
}

/*
 * Process the help command.
 * help * shows all options
 */
void helpcmd()
{
            register int c;
            FILE         *fp;
	    int          count = 0, option;

	    c = getnb();
            if (c >= 65 && c <= 90)
                c = c + 32;

	    if (c == 0) c = '*';
	    option = c;

            if ((fp = fopen ("focal.hlp","r")) == NULL)
	       diag ("Help file missing");

            while((fgets(abuf, 80, fp)) != NULL) {
		     if (option == '*') {
			printf("%s", abuf);
			count++;
			if (count % 24 == 0) {
			   printf("-- More --");
			   if ((c = getch())=='\033')
			      break;
			   putchar('\n');
			}
		     }
		     else {
			  if (abuf[0] == option)
			       printf("%s", abuf);
		     }
	    }
            fclose(fp);

            if (c != 42) {
               while ((c=getnb())!=0 && c!=';')
               ;
            }
}

/*
 * Process the ask command.
 * The "ask" has already been read in.
 * The funny altmode thing, where a variable
 * is left unchanged, is not implemented.
 * The input expression must be a legal floating
 * point number, although no checking is done.
 */
void askcmd()
{
	register struct	sym	*sp;
	register int	c;
	int x, y;

	while ((c=getnb())!=0 && c!=';') {

		if (c == '@') {
			c = getnb();
			if (c=='E') {
			    clearscreen();
			    continue;
			}
			if (c=='L') {
			    clearline();
			    continue;
			}
			if (c == 'A') {
			    c = getnb();
			    x = getnum(c);
			    setattribute(x);
			    continue;
			}
			if (c == 'C') {
			    c = getnb();
			    x = getnum(c);
			    if (getnb() != '.')
				diag("Missing . in format");
			    y = getnum(getnb());
			    setcolor(x,y);
			    continue;
			}
			if (c==0 || c==';' || c==',') {
			    screenposition(0,0);
			    continue;
			  }
			  else {
			    x = getnum(c);
			    if (getnb() != '.')
				diag("Missing . in format");
			    y = getnum(getnb());
			    screenposition(x,y);
			    continue;
			}
		}
		if (c == ':') {
			c = getnb();
			x = getnum(c);
			settab(x);
			continue;
		}

		if (c == '!') {
			putchar('\n');
			continue;
		}

		if (c == '#') {
			putchar('\r');
			continue;
		}

		if (c == '"') {
			while ((c = *ctp++)!=0 && c!='"')
				putchar(c);
			if (c != 0)
				continue;
			diag("Missing `\"' in ask");
		}

		if (c == ',')
			continue;
		--ctp;
		sp = getsym();

		if (reserved == 1) {
		     reserved = 0;
		     diag("Can't set reserved var");
		}

		printf(": ");
		if (gets(abuf) == NULL) {
			putchar('\n');
			diag("EOF in ask");
		}
		if ((abuf[0]>='A' && abuf[0]<='Z') || (abuf[0]>='a' && abuf[0]<='z'))
		     sp->s_un.s_value = abuf[0];
		  else
		     sp->s_un.s_value = atof(abuf);
	}
	--ctp;
}


/*
 * Process the increment command.
 */
void incrementcmd()
{
	register struct	sym	*sp;
	register int	c;
        int      increment;
        double   value;
        char     *oldctp;

	while ((c=getnb())!=0 && c!=';') {

		if (c == ',')
			continue;
                
                oldctp = ctp;
                if (c == '+' || c == '-') {
                   if (c == '+')
                        increment=1;
                   if (c == '-')
                        increment=-1;
		   /* ++ctp; */
                   }
                 else
                   diag("Wrong increment format");

                sp = getsym();

		if (reserved == 1) {
		     reserved = 0;
		     diag("Can't set reserved var");
		}

		ctp = oldctp;
                sp->s_un.s_value = eval()+increment;
	}
	--ctp;
}



/*
 * Complain about bad line
 * numbers. Used all over the place.
 */
void badline()
{
	diag("Bad line number");
}


/*
 * Effectively use control stack
 */
static struct control *ccb_free = NULL;


/*
 * Obtain a control stack entry.
 * Check free list firstly, then call malloc
 * only when free list is empty.
 *  -- added by Akira Kida
 */
struct control *
newcontrol()
{
	struct control *cp;
	
	if (ccb_free != NULL) {
		cp = ccb_free;
		ccb_free = cp->c_fp;
	} else if ((cp = (struct control *)
		     malloc(sizeof(struct control))) == NULL) {
		diag("Out of space (control stack)");
	}
	return cp;
}

/*
 * Free control stack that is no longer needed.
 * Just return one to the free list.
 */
void
freecontrol(cp)
struct control *cp;
{
	cp->c_fp = ccb_free;
	ccb_free = cp;
}


/*
 * Push an entry onto the control stack
 *
 * There are two formats corresponding to
 * "for" and "do" statmenets.  "for" statiement
 * format differs from "do" statement format in 
 * that the loop variables are saved.
 *  -- added by Akira Kida
 */
void pushcntl()
{
	register struct control *cp;

	cp = newcontrol();
	cp->c_fp = control;
	control  = cp;
	cp->c_mode = mode;
	cp->c_tp = ctp;
	cp->c_lp = clp;
	if (mode == C_FOR) {
		cp->c_sp = forsp;
		cp->c_limit = forlimit;
		cp->c_step = forstep;
	}
}


/*
 * Pop an entry from the control stack
 */
void popcntl()
{
	register struct control *cp;

	cp = control;
	control = cp->c_fp;
	ctp = cp->c_tp;
	clp = cp->c_lp;
	mode = cp->c_mode;
	if (mode == C_FOR) {
		forsp = cp->c_sp;
		forlimit = cp->c_limit;
		forstep = cp->c_step;
	}
	freecontrol(cp);
}


/*
 * Pop a "do" format entry from
 * the control stack, restoring all of the
 * global variables.
 */
void popdo()
{
	if (control == NULL)
		diag("Return not in do");
	popcntl();
}


/*
 * Pop a "for" format item from the
 * control stack, restoring all the global
 * variables.
 */
void popfor()
{
	if (control == NULL)
		diag("For stack botch");
	popcntl();
}



/*
 * Dig in the control stack,
 * looking for "for" stack entries that
 * are controlling the variable whose symbol
 * table entry is pointed to by `sp'. Rip
 * them out. This makes everything work out
 * if you "go" out of a loop and then "for"
 * on the same variable.
 */
void clearfors(sp)
register struct	sym	*sp;
{
	register struct	control	*cp1;
	register struct	control	*cp2;

	if (mode==C_FOR && forsp==sp)
		popfor();
	else {
		cp1 = NULL;
		cp2 = control;
		while (cp2 != NULL) {
			if (cp2->c_mode==C_FOR && cp2->c_sp==sp) {
				if (cp1 == NULL)
					control = cp2->c_fp;
				else
					cp1->c_fp = cp2->c_fp;
				freecontrol(cp2);
				break;
			}
			cp1 = cp2;
			cp2 = cp2->c_fp;
		}
	}
}

/*
 * Inject a line of text, stored in
 * the normal command line buffer, into the
 * saved indirect program. The argument `c'
 * is the first character of the line
 * number, which is assumed to be valid.
 */
void inject(c)
register int	c;
{
	register struct	line	*lp1;
	register struct line	*lp2;
	register struct	line	*lp3;
	struct lno	lno;

	getlno(&lno, c);
	if (lno.ln_type != LN_LINE)
		diag("Illegal line number");
	lp1 = NULL;
	lp2 = line;
	while (lp2 != NULL
	&& (lp2->l_gno < lno.ln_gno
	|| (lp2->l_gno==lno.ln_gno&&lp2->l_lno<=lno.ln_lno))) {
		if (lp2->l_gno == lno.ln_gno
		&&  lp2->l_lno == lno.ln_lno) {
			lp3 = lp2;
			lp2 = lp2->l_fp;
			if (lp1 == NULL)
				line = lp2;
			else
				lp1->l_fp = lp2;
			free((char *) lp3);
			break;
		}
		lp1 = lp2;
		lp2 = lp2->l_fp;
	}
	if ((c=getnb()) != 0) {
		lp3 = alocline(--ctp);
		lp3->l_fp  = lp2;
		lp3->l_gno = lno.ln_gno;
		lp3->l_lno = lno.ln_lno;
		strcpy(lp3->l_text, ctp);
		if (lp1 == NULL)
			line = lp3;
		else
			lp1->l_fp = lp3;
	}
}


int getline(cp, fp)
register char *cp;
register FILE *fp;
{
	register c;

	while ((c=getc(fp))!=EOF && c!='\n')
		*cp++ = c;
	if (c == EOF)
		return (0);
	*cp = 0;
	return (1);
}


void typecmd()
{
	register char *fmt;
	register c;
static	char fmtb[20];
static	int ifmtb = 1;
	int x, y;
	double value;

	if (ifmtb) {
		strcpy(fmtb, "%9.4f");
		ifmtb--;
		}
	fmt = fmtb;
	while ((c=getnb())!=0 && c!=';') {

		if (c == '@') {
			c = getnb();
			if (c=='E') {
			    clearscreen();
			    continue;
			}
			if (c=='L') {
			    clearline();
			    continue;
			}
			if (c == 'A') {
			    c = getnb();
			    x = getnum(c);
			    setattribute(x);
			    continue;
			}
			if (c == 'C') {
			    c = getnb();
			    x = getnum(c);  /* foreground color */
			    if (getnb() != '.')
				diag("Missing . in format");
			    y = getnum(getnb()); /* background color */
			    setcolor(x,y);
			    continue;
			}
			if (c==0 || c==';' || c==',') {
			    screenposition(0,0);
			    continue;
			  }
			  else {
			    x = getnum(c);
			    if (getnb() != '.')
				diag("Missing . in format");
			    y = getnum(getnb());
			    screenposition(x,y);
			    continue;
			}
		}
		if (c == ':') {
			c = getnb();
			x = getnum(c);
			settab(x);
			continue;
			}
		if (c == '%') {
			if ((c=getnb())==0 || c==';' || c==',') {
				strcpy(fmtb, "%6e");
				fmt = fmtb;
				--ctp;
				continue;
			}
			x = getnum(c);
			if (getnb() != '.')
				diag("Missing . in format");
			y = getnum(getnb());
			sprintf(fmtb, "%%%d.%df", x, y);
			fmt = fmtb;
			continue;
		}
		if (c == ',')
			continue;
		if (c == '!') {
			putchar('\n');
			continue;
		}
		if (c == '#') {
			putchar('\r');
			continue;
		}
		if (c == '"') {
			while ((c = *ctp++)!='\0' && c!='"')
				putchar(c);
			if (c == '\0') {
				diag("Missing `\"' in type");
				break;
			}
			continue;
		}
		--ctp;
		if (strstr(ctp,"fout(") == ctp)
		    foutflag = 1;
		value=eval();
		if (foutflag == 0)
		      printf(fmt, value);
		    else {
			printf("%c",foutvalue);
			foutflag = 0;
		    }
	}
	--ctp;
}

void save(lnop, fp)
register struct lno *lnop;
FILE *fp;
{
	struct lno lno;
	register struct line *lp;
	register tgroup, lgroup;

	if (lnop == NULL) {
		lno.ln_type = LN_ALL;
		lnop = &lno;
	}
	lp = line;
	if (lnop->ln_type!=LN_NONE && lnop->ln_type!=LN_ALL) {
		while (lp!=NULL && lp->l_gno<lnop->ln_gno)
			lp = lp->l_fp;
		if (lp==NULL || lp->l_gno!=lnop->ln_gno)
			diag("Line not found");
		if (lnop->ln_type == LN_LINE) {
			while (lp!=NULL && lp->l_lno!=lnop->ln_lno)
				lp = lp->l_fp;
			if (lp == NULL)
				diag("Line not found");
		}
	}
	while (lp != NULL) {
		putline(lp, fp);
		if (lnop->ln_type == LN_LINE)
			break;
		lgroup = lp->l_gno;
		if ((lp = lp->l_fp) != NULL) {
			tgroup = lp->l_gno;
			if (lnop->ln_type==LN_GRP && tgroup!=lnop->ln_gno)
				break;
			if (tgroup != lgroup)
				putc('\n', fp);
		}
	}
}

void erasesyms()
{
	register struct sym *sp1, *sp2;
	int	i;
	
	for (i = 0; i < N_HASH; ++i) {
		sp1 = sym[i];
		sym[i] = NULL;
		while (sp1 != NULL) {
			sp2 = sp1->s_fp;
			free((char *) sp1);
			sp1 = sp2;
		}
	}
}
/*
 * Focal, 1981.
 * Expression evaluation.
 */

/*
 * Evaluate an expression.
 */
double eval()
{
	double		val;
	double		rop;
	register int	c;

	if ((c=getnb())=='+' || c=='-') {
		val = primary();
		if (c == '-')
			val = -val;
	} else {
		--ctp;
		val = primary();
	}
	while ((c=getnb())=='+' || c=='-') {
		rop = primary();
		if (c == '+')
			val = val + rop;
		else
			val = val - rop;
	}
	--ctp;
	return (val);
}

double primary()
{
	double		val;
	double		rop;
	register int	c;

	val = secondary();
	while ((c = getnb())=='/') {
		rop = secondary();
		if (rop == 0)
		     diag("Division by zero");
		val = val / rop;
	}
	--ctp;
	return (val);
}


double secondary()
{
	double          val;
	double          rop;
	register int    c;

	val = tertiary();
	while ((c = getnb())=='*') {
		rop = tertiary();
		if (checkoverflow(val,rop,1) == 1)
		     diag("Overflow");
		val = val * rop;
	}
	--ctp;
	return (val);

}

double tertiary()
{
	double          val;
	double          rop;
	register int    c;

	val = term();
	while ((c = getnb())== '^') {
		rop = term();
		if (checkoverflow(val,rop,2) == 1)
		     diag("Overflow");
		val = pow(val, rop);
	}
	--ctp;
	return (val);
}



double term()
{
	register int	c;
	register char	*cp;
	double		val;
	register int	fsign;
	register int	fdot;
	register int	fexp;
	register int	type;
	register int	subs = 0;
	register struct	sym	*sp;
	char		id[NID];
	char		nbuf[20];

	if ((c = getnb())=='(' || c=='[' || c=='<') {
		val = eval();
		if (++c != ')')
			++c;
		if (c != getnb())
			diag("Mismatched enclosures");
		return (val);
	}
	if (c=='.' || isdigit(c)) {
		fsign = 1;
		fexp = 0;
		fdot = 0;
		if (c == '.')
			++fdot;
		cp = &nbuf[0];
		for (;;) {
			if (cp >= &nbuf[19])
				diag("Number too long");
			*cp++ = c;
			if ((c = *ctp++) == '.') {
				if (fdot++)
					break;
			} else if (c == 'e') {
				if (fexp++)
					break;
				fsign = 0;
				fdot = 1;
			} else if (c=='+' || c=='-') {
				if (fsign++)
					break;
			} else if (!isdigit(c))
				break;
		}
		--ctp;
		*cp = '\0';
		return (atof(nbuf));
	}
	if (!isalpha(c))
		diag("Expression syntax");
	cp = &id[0];
	do {
		if (cp < &id[NID-1])
			*cp++ = c;
		c = *ctp++;
	} while (isalnum(c));
	*cp = 0;
#ifdef FUNCTIONS
	if (id[0]=='f' && (sp=lookup(id, S_FUNC, 0))!=NULL) {
		while (c==' ' || c=='\t')
			c = *ctp++;
		if (c != '(')
			diag("Missing `(' for function");
		val = eval();
		if (getnb() != ')')
			diag("Missing `)' for function");
		return ((*sp->s_un.s_fp)(val));
	}
#endif
	type = S_SCAL;
	while (c==' ' || c=='\t')
		c = *ctp++;
	if (c == '(' || c == '[' || c == '<') {
		type = S_ARRAY;
		subs = (int) eval();
		c = getnb();
		if (c != ')' && c != ']' && c != '>')
			diag("Missing ) in subscript");
	} else
		--ctp;
	if ((sp=lookup(id, type, subs)) == NULL)
		diag("Undefined variable");
	return (sp->s_un.s_value);
}


struct	sym *
lookup(id, type, subs)
char *id;
register type;
int	subs;
{
	register struct sym *sp;
	int	ix;
	
	ix = hashsym(id, type, subs);
	sp = sym[ix];
	while (sp != NULL) {
		if (sp->s_type == type
		&& (type!=S_ARRAY || sp->s_subs==subs)
		&&  strcmp(id, sp->s_id) == 0)
			break;
		sp = sp->s_fp;
	}
	return (sp);
}

struct sym *
getsym()
{
	register c;
	char id[NID];
	register char *cp;
	register struct sym *sp;
	int subs = 0, type;
	int	ix;
	
	if (isalpha(c = getnb()) == 0)
		diag("Missing variable");
	cp = &id[0];


	do {
		if (cp < &id[NID-1])
			*cp++ = c;
		c = *ctp++;
	} while (isalnum(c));
	*cp = 0;
	type = S_SCAL;
	while (c==' ' || c=='\t')
		c = *ctp++;
	if (c == '(' || c == '[' || c == '<') {
		type = S_ARRAY;
		subs = (int) eval();
		c = getnb();
		if (c != ')' && c != ']' && c != '>')
			diag("Bad subscript");
	} else
		--ctp;
	if ((sp=lookup(id, type, subs)) == NULL) {
		sp = (struct sym *)malloc(sizeof(*sp)+strlen(id)+1);
		if (sp == NULL)
			diag("Out of space (symbols)");
		ix = hashsym(id, type, subs);
		sp->s_fp = sym[ix];
		sym[ix] = sp;
		sp->s_type = type;
		sp->s_subs = subs;
		strcpy(sp->s_id, id);
	}
	if (strcmp(id,"pi")==0)
	     reserved = 1;
	return (sp);
}

#ifdef FUNCTIONS
double fsin(arg)
double arg;
{
	return (sin(arg));
}

double fcos(arg)
double arg;
{
	return (cos(arg));
}

double fexp(arg)
double arg;
{
	return (exp(arg));
}

double flog(arg)
double arg;
{
	if (arg<=0)
	   diag("Flog <= 0.0");
	return (log(arg));
}

double fatn(arg)
double arg;
{
	return (atan(arg));
}

double fsqt(arg)
double arg;
{
	if (arg < 0.0)
		diag("Fsqt < 0.0");
	return (sqrt(arg));
}

double fabt(arg)
double arg;
{
	if (arg < 0)
		return (-arg);
	return (arg);
}

double fsgn(arg)
double arg;
{
	if (arg < 0)
		return (-1.0);
	if (arg == 0)
		return (0.0);
	return (1.0);
}

double fitr(arg)
double arg;
{
	if (arg < 0)
		return (-floor(-arg));
	if (arg == 0)
		return (0.0);
	return (floor(arg));
}

double fran(arg)
double arg;
{
	return (drand48());
}

double fusr(arg)
double arg;
{
       int   ii,l;
       char  *numbuf[20];

       c2 = 1;
       strcpy(copiactp,ctp);
       strcpy(ctp,"");
       for (ii=0;ii<=strlen(user);++ii) {
	   if (user[ii] == '&') {
	       gcvt(arg, 20, numbuf);
	       strcat(ctp, numbuf);
	       }
	    else {
	       l = strlen(ctp);
	       ctp[l]=user[ii];
	       ctp[l+1]='\0';
	       }
       }
       arg=eval();
       strcpy(ctp,copiactp);
       return(arg);
}

double fout(arg)
double arg;
{
     if (foutflag == 1)
	foutvalue = (int)arg;
     return(0);
}

double fin(arg)
double arg;
{
     char key;

     if (finflag == 1)
	return(key = getche());
     return(0);
}


#endif
/*
 * Focal, 1981.
 * Operating system dependent code.
 * Most has something to do with the syntax of
 * a file name or the format of the directory of the
 * disc; most of this is in the library command.
 */

#ifdef	__STDC__
#define	unlink	remove
#endif

#ifdef DIR_SUPPORT
# ifdef	DOS
#  include <dos.h>
# else
#  include <sys/types.h>
#  include <sys/stat.h>
#  include <fcntl.h>
#  include <unistd.h>
#  ifdef DIRENT
#   include <dirent.h>
#   define	direct	dirent
#  else
#   include <sys/dir.h>
#  endif
struct stat	sb;
struct direct	db;
# endif
#endif

/*
 * Process the library command.
 * This command (sadly) requires a rather
 * detailed knowledge of the file system of
 * the operating system.
 */
void librarycmd()
{
	register char	*p;
	register int	c;
	register int	d;
	register char	*sctp;
	register struct line	*lp1;
	register struct line	*lp2;
	register FILE	*fp;
	register struct sym     *sp;
	char            *stopstring;
        int             nf;
	char            buff[20];
        char            timebuf[10], datebuf[10];
	double          value;
	int             flagrun = 0;
        int             count;

	c = getnb();

	if (isupper(c))
		c = tolower(c);

        if (c!='c' && c!='s' && c!='l' && c!='d' && c!='i' && c!='o' && c!='f'
	    && c!='t' && c!='a' && c!='r' && c!='v' && c!='m' && c!='p')
		diag("Bad library command");

	while (isalpha(*ctp))
		++ctp;

	while ((d = *ctp)==' ' || d=='\t')
		++ctp;

	if (c!='l' && d==0)
		diag("Missing file name");

	if (c=='i' || c=='o' || c=='f' || c=='t' || c=='a') {
		nf = getnb() - 48;
		if (!(nf >=0 && nf<=9))
		    diag("Wrong file channel");
		++ctp;   /* skip comma after channel number */
	}
	p = ctp;

	if (c!='t' && c!='a') {
	     while (*ctp != 0)
		++ctp;
	}

	if (c == 'r') {
	   c = 'c';
	   flagrun = 1;
	}

	switch (c) {

	case 'o':
	     if (filetable[nf] == 'X') {
		     fc[nf] = fopen(p,"wt");
		     filetable[nf] = 'W';
		  }
		else
		   diag("Channel in use");
	      break;

	case 'i':
	     if (filetable[nf] == 'X') {
		  if ((fc[nf]=fopen(p,"rt")) == NULL)
		       diag("Cannot open");
		  filetable[nf]='R';
		  rewind(fc[nf]); }
	       else
		  diag("Channel in use");
	     break;

	case 'f':
	    fclose(fc[nf]);
	    filetable[nf]='X';
	    break;

	case 't':
            if (filetable[nf] != 'W')
               diag("Not output file");

            /* test if write single char with fout */
	    if (strstr(ctp,"fout(") == ctp) {
	       foutflag = 1;
	       value = eval();
	       fputc(foutvalue,fc[nf]);
	       foutflag = 0;
	       while ((c=getnb())!=0 && c!=';')
		 ;
	       --ctp;
	       break;
	    }

            /* write number */
	    while ((c=getnb())!=0 && c!=';') {

		if (c == '@' || c == '"')
			diag("Wrong format");

		if (c == ',')
			continue;
		--ctp;
		value=eval();
		fprintf(fc[nf],"%g\n",value);
            }
            --ctp;
	    break;

	case 'a':
            if (filetable[nf] != 'R')
               diag("Not input file");
            
            if (strstr(ctp,"fin(") != NULL) {
	       sp = getsym();
	       if (getnb() != '=')
			diag("Missing = sign");
	       if ((value=fgetc(fc[nf])) !=NULL) {
		     sp->s_un.s_value = (int) value;
		   }
		  else  {
		     fclose(fc[nf]);
		     filetable[nf]='X';
		  }
	       while ((c=getnb())!=0 && c!=';')
		 ;
	       --ctp;
	       break;
	    }
	    while ((c=getnb())!=0 && c!=';') {

		if (c == '@' || c == '"')
			diag("Wrong format");

		if (c == ',')
			continue;
		--ctp;
		sp = getsym();

		if (reserved == 1) {
		     reserved = 0;
		     diag("Can't set reserved var");
		}

		if (fgets(buff,19,fc[nf]) !=NULL) {
                     value = strtod(buff, &stopstring);
                     sp->s_un.s_value = value;
                   }
                  else  {
		     fclose(fc[nf]);
                     filetable[nf]='X';
                  }
            }
            --ctp;
	    break;

	case 'c':
	    if (strstr(p,extension) == NULL) {
		    p = strcat(p,extension);
		    ++ctp; ++ctp; ++ ctp;
		}

		if ((fp=fopen(p, "r")) == NULL)
			diag("Cannot open");

		filename = strdup(p);

		lp1 = line;
		while (lp1 != NULL) {
			lp2 = lp1->l_fp;
			free ((char *) lp1);
			lp1 = lp2;
		}
		line = NULL;
		sctp = ctp;
		while (getline(abuf, fp) != 0) {
			ctp = abuf;
			if ((c=getnb()) != 0) {
				if (isdigit(c) == 0)
					diag("Direct line in call");
				inject(c);
			}
		}
		fclose(fp);
		ctp = sctp;
		if (flagrun == 1) {
		   flagrun = 0;
		   strcpy(cbuf,"go");
		   execute = 1;
		}
		break;

	case 'm':
	    if (strstr(p,extension) == NULL) {
		    p = strcat(p,extension);
		    ++ctp; ++ctp; ++ ctp;
		}

		if ((fp=fopen(p, "r")) == NULL)
			diag("Cannot open");

		filename = strdup(p);
	      /*
		lp1 = line;
		while (lp1 != NULL) {
			lp2 = lp1->l_fp;
			free ((char *) lp1);
			lp1 = lp2;
		}
		line = NULL; */
		sctp = ctp;
		while (getline(abuf, fp) != 0) {
			ctp = abuf;
			if ((c=getnb()) != 0) {
				if (isdigit(c) == 0)
					diag("Direct line in call");
				inject(c);
			}
		}
		fclose(fp);
		ctp = sctp;
		/* if (flagrun == 1) {
		   flagrun = 0;
		   strcpy(cbuf,"go");
		   execute = 1;
		}  */
		break;

	case 'd':
#ifdef	vax
		if (delete(p) < 0)
#else
		if (unlink(p) < 0)
#endif
			diag("Cannot delete");
		break;

	case 'l':
#ifndef	DIR_SUPPORT
		diag("Library list not implemented");
#else
	{
#ifdef	DOS
		int	attr = _A_RDONLY | _A_ARCH;
		int	rc;
		static struct find_t	de;
		static char	fname[FILENAME_MAX];
		char	*s;
		
		if (d == 0)
			strcpy(fname, "*.*");
		else {
			strcpy(fname, p);
			s = fname + strlen(fname) - 1;
			if (*s == '\\')
				strcat(fname, "*.*");
			else if (*s == '.')
				strcat(fname, "\\*.*");
		}
		rc = _dos_findfirst(fname, attr, &de);
		count = 0;
		while (!rc) {
			if ((de.attrib & _A_SUBDIR) == 0
			    && strcmp(de.name, ".") != 0
                            && strcmp(de.name, "..") != 0) {
                                datestr( de.wr_date, datebuf );
                                timestr( de.wr_time, timebuf );
				printf("%-13s  %8ld   %8s  %8s\n", de.name,de.size, datebuf, timebuf);
				count++;
				if (count % 24 == 0)
				{
				     printf("-- More --");
				    if ((c = getch())=='\033')
				       break;
				    putchar('\n');
				 }
			}
			rc = _dos_findnext(&de);
		}
#else
#ifdef DIRENT
		register struct dirent *de;
		register DIR *dp;

		if (d == 0)
			p = ".";
		if ((dp = opendir(p)) == NULL) {
			perror("focal");
			diag("Bad directory");
		}
		while ((de = readdir(dp)) != NULL) {
			if (de->d_ino == 0
			    ||  strcmp(de->d_name, ".") == 0
			    ||  strcmp(de->d_name, "..") == 0)
				continue;
			printf("%.*s\n", de->d_reclen, de->d_name);
		}
		closedir(dp);
#else
		register int	fd = 0;
		
		if (d == 0)
			p = ".";
		if (stat(p, &sb) < 0
		|| (sb.st_mode&S_IFMT) != S_IFDIR
		|| (fd = open(p, 0)) < 0)
			diag("Bad directory");
		while (read(fd, &db, sizeof(db)) == sizeof(db)) {
			if (db.d_ino == 0
			||  strncmp(db.d_name, ".",  DIRSIZ) == 0
			||  strncmp(db.d_name, "..", DIRSIZ) == 0)
				continue;
			printf("%.*s\n", DIRSIZ, db.d_name);
		}
		close(fd);
#endif
#endif
	}
#endif
		break;

	case 's':

		if (strstr(p,extension) == NULL) {
		    p = strcat(p,extension);
		    ++ctp; ++ctp; ++ ctp;
		}

		if ((fp=fopen(p, "w")) == NULL)
			diag("Cannot create");

		filename = strdup(p);

		save(NULL, fp);
		fclose(fp);
		break;

	case 'v':
               if ((fp = fopen (p,"r")) == NULL)
		    diag("Cannot open");
                 else
                   {  count = 0;
		      while ((c = fgetc(fp)) != EOF) {
                          printf("%c", c);
			  if (c == '\n')
			  {
                              count++;
			      if (count % 24 == 0)
                              {
				 printf("-- More --");
				 if ((c = getch())=='\033')
				    break;
				 putchar('\n');
                              }
                          }
		      }
		      printf("view %i lines\n",count);
                      fclose(fp);
		   }
		break;

	case 'p':
	       if ((fp = fopen (p,"r")) == NULL)
		    diag("Cannot open");
		 else
		   { while ((c = fgetc(fp)) != EOF) {
			  fputc(c,fc[0]);
			  }
		     fprintf(fc[0],"\f");
		   }
		break;
	}
}

/*
 * Set up to catch the user's
 * ^C interrupt.
 */
void catchcc()
{
	signal(SIGINT, (void (*) ARG((int)))onintr);
}

/*
 * This routine is called by
 * the ^C signal handler. All it does
 * is set a flag, which is looked at
 * by the dispatcher.
 */
void onintr()
{
	++intflag;
}
/*
 * Focal, 1981.
 * A number of small routines that
 * don't go anywhere else.
 */

/*
 * Put out the text line
 * pointed to by `lp' to the FILE
 * pointed to by `fp'.
 * Used any time a source line is
 * printed.
 */
void putline(lp, fp)
register struct line *lp;
FILE *fp;
{
	fprintf(fp, "%02d.%02d %s\n", lp->l_gno, lp->l_lno, lp->l_text);
}

/*
 * Get a line number.
 * The `c' argument is the first
 * character, and is assumed to be ok.
 * The line number, along with its general
 * shape, is packed into the structure
 * pointed to by `lnop'.
 */
void getlno(lnop, c)
register struct lno *lnop;
register c;
{
	register gn, ln;
	static char badlno[] = "Bad line or group number";

	if (c < 0)
		c = getnb();
	if (c=='\0' || c==';') {
		--ctp;
		lnop->ln_type = LN_NONE;
		return;
	}
	if (c=='A' || c=='a') {
		while (isalpha(*ctp))
			++ctp;
		lnop->ln_type = LN_ALL;
		return;
	}
	if (!isdigit(c))
		diag(badlno);
	if ((gn = getnum(c))<1 || gn>99)
		diag(badlno);
	if (*ctp != '.') {
		lnop->ln_gno = gn;
		lnop->ln_lno = 0;
		lnop->ln_type = LN_GRP;
		return;
	}
	++ctp;
	if ((ln=getnum(*ctp++)) == 0) {
		lnop->ln_gno = gn;
		lnop->ln_lno = 0;
		lnop->ln_type = LN_GRP;
		return;
	}
	if (ln<1 | ln>99)
		diag(badlno);
	lnop->ln_gno = gn;
	lnop->ln_lno = ln;
	lnop->ln_type = LN_LINE;
}

/*
 * Get a number. The argument
 * `c' is the first character of the
 * number, and is assumed to be valid.
 * Return the number read.
 */
int getnum(c)
register c;
{
	register n;

	n = 0;
	while (isdigit(c)) {
		n = 10*n + c - '0';
		c = *ctp++;
	}
	--ctp;
	return (n);
}

/*
 * Allocate a new line, with a
 * data array large enough to hold the
 * string pointed to by `cp'.
 * The line and group number fields are
 * not filled in.
 * Return a pointer to the line.
 */
struct line *
alocline(cp)
register char *cp;
{
	register struct line *lp = NULL;

	lp = (struct line *) malloc(sizeof(*lp)+strlen(cp)+1);
	if (lp == NULL)
		diag("Out of memory");
	return (lp);
}

/*
 * Print a diagnostic. The `s'
 * argument is an error message. The
 * offending line is displayed, with a flag
 * at the point where the scan failed.
 * This routine does not return; it just
 * does a non local goto back to the command
 * dispatcher.
 */
void diag(s)
char *s;
{
	register struct line *lp;
	register char *cp;

	printf("%s!\n", s);
	if ((lp=clp) != NULL) {
		putline(lp, stdout);
		printf("      ");
		cp = lp->l_text;
	} else {
		printf("*%s\n ", cbuf);
		cp = cbuf;
	}
	while (cp < ctp) {
		putchar(' ');
		++cp;
	}
	printf("^\n");
	while (control != NULL)
		popdo();
	longjmp(env, 0);
}

/*
 * Get the next non blank
 * character from the current source line.
 * Return it.
 */
int getnb()
{
	register c;

	while ((c = *ctp++)==' ' || c=='\t')
		;
	return (c);
}
/*
 * drand48
 *
 * return pseudo-random number in interval [0.0, 1.0)
 *
 */
double drand48()
{
	return (double) (rand() / 32768.0);
}

/*
* clearscreen - clear the screen
*/
 
clearscreen (void)
{
   printf ("\033[2J");
}
 
/*
* clearline - clear the line
*/
 
clearline (void)
{
   printf ("\033[2K");
}
 
/*
* screen position - position on the screen
  check for position in 0..24 e 0..79 */
screenposition (x,y)
{
   printf ("\033[%1d;%1dH",(x>=0 && x<=24)?x:24,(y>=0 && y<=79)?y:79);
}

/* check for colors in 0..7 */
setcolor (x,y)
{
   printf ("\033[3%1d;4%1dm",(x>=0 && x<=7)?x:7,(y>=0 && y<=7)?y:0);
}

/* check for attribute in: 0..8 */
setattribute (x)
{
   printf ("\033[%1dm",(x>=0 && x<=8)?x:0);
}

/* check for display mode in 0..17 */
setdisplaymode(x,y,n)
{
   printf ("\033[=%1dh",(x>=0 && x<=17)?x:3);
}

settab(x)
{
   printf ("\033[79D");    /* moves cursor to line beginning */
   printf ("\033[%1dC",(x>=0 && x<=79)?x:0);
}


char *replace(char *st, char *orig, char *repl){
  static char buffer[4096];
  char  *ch;
  int    change=0;
  
  if (strlen(orig) == 0) {
     strcpy(buffer, st);
     strcat(buffer,repl);
     return(buffer);   /* append to end */
  }

  if (strlen(repl) == 0) {
     strcpy(buffer, orig);
     strcat(buffer, st);
     return(buffer);   /* append to begin */
  }

  if (strstr(repl, orig) != NULL )
     change=1;

  do {
     if(!(ch = strstr(st, orig)))
	return st;
     strncpy(buffer, st, ch-st);
     buffer[ch-st] = 0;
     sprintf(buffer+(ch-st), "%s%s", repl, ch+strlen(orig));
     if (change == 1)
	return buffer;
     strcpy(st,buffer);
     buffer[0]='\0';
  } while (1);

  return buffer;
}

void tracedata() {

    register struct line *lp;

    if ((lp=clp) != NULL)
	   fprintf(stdout, "[%02d.%02d] ", lp->l_gno, lp->l_lno);
}


void delay(float value) {

    time_t cstart, cend; /* For clock            */

    cstart = clock();    /* Use clock for timing to hundredths of seconds */

    do {
	 cend = clock();
    } while (((float)cend-cstart)<=value);

    /* printf( "\nclock:\t\t\t%4.2f milliseconds.",
	    ((float)cend - cstart)); */

}

void mysetpixel(riga,colonna,colore)
{

 int cella, value, bitpos;
 static int mask[]={1,2,4,8,16,32,64,128};

 switch(graphicmode) {
    case 1:
      cella = (riga & 1) * 8192 + (riga / 2) * 80 + colonna / 8;
      break;
    case 2:
      cella = (riga * 80 + colonna / 8);
      break;
    default:
    ;
  }

  value = *( vdu + cella);
  bitpos = 7 - (colonna % 8);

  if (colore == 1)
	value = value | mask[bitpos];
      else
	value = value & (255 - mask[bitpos]);

  *(vdu + cella) = value;
}

void swap(int *i, int *j) {
     int t = *i;
     *i = *j;
     *j = t;
}

int checkoverflow(i,j,n){
int v;

    v = 0;
    switch(i) {

      case 1: /* multiplication */
	 if (!(i != 0 && j != 0))
	     if (log10(fabs(i)) * log10(fabs(j)) > 308)
		v = 1;
	 break;
      case 2: /* power */
	 if (i!= 0)
	    if (log10(fabs(i)) * j > 308)
		v = 1;
	 break;
    }
    return(v);
}

void setfunctions() {
	builtin("fsin", fsin);
        builtin("fcos", fcos);
	builtin("fexp", fexp);
	builtin("flog", flog);
	builtin("fatn", fatn);
	builtin("fsqt", fsqt);
	builtin("fabs", fabt);
	builtin("fsgn", fsgn);
	builtin("fitr", fitr);
	builtin("fran", fran);
	builtin("fusr", fusr);
	builtin("fout", fout);
	builtin("fin",fin);
	builtinvar("pi",atan(1)*4);
}

/* Takes unsigned time in the format:               fedcba9876543210
 * s=2 sec incr, m=0-59, h=23                       hhhhhmmmmmmsssss
 * Changes to a 9-byte string (ignore seconds):     hh:mm ?m
 */
char *timestr( unsigned t, char *buf )
{
    int h = (t >> 11) & 0x1f, m = (t >> 5) & 0x3f;

    sprintf( buf, "%2.2d:%02.2d %cm", h % 12, m,  h > 11 ? 'p' : 'a' );
    return buf;
}

/* Takes unsigned date in the format:               fedcba9876543210
 * d=1-31, m=1-12, y=0-119 (1980-2099)              yyyyyyymmmmddddd
 * Changes to a 9-byte string:                      mm/dd/yy
 */
char *datestr( unsigned d, char *buf )
{

    sprintf( buf, "%2.2d/%02.2d/%02.2d",
	     (d >> 5) & 0x0f, d & 0x1f, ((d >>9) + 80)%100);
    return buf;
}

